#include <iostream>
#include <string>
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <vector>

#include "editServerData.h"

#pragma comment(lib, "ws2_32.lib")
#define BUFSIZE 4096

char * IPaddress = "localhost";
int PORT = 2222;
bool konec = false;

WORD wVersionRequested = MAKEWORD(2,2);
WSADATA data;
SOCKET mySocket;
sockaddr_in serverSock;
hostent * gConnectionHost;

SOCKET startViewerListening(char * serverAddress, int connectionPort)
{
	if (WSAStartup(wVersionRequested, &data) != 0)
	{
		std::cerr << "Nepodailo se inicializovat sokety" << std::endl;
		return INVALID_SOCKET;
	}
	if ((gConnectionHost = gethostbyname(serverAddress)) == NULL)
	{
		std::cerr << "patn adresa" << std::endl;
		WSACleanup();
		return INVALID_SOCKET;
	}
	if ((mySocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) == -1)
	{
		std::cerr << "Nelze vytvoit soket" << std::endl;
		WSACleanup();
		return INVALID_SOCKET;
	}
	serverSock.sin_family = AF_INET;
	serverSock.sin_port = htons(connectionPort);
	memcpy(&(serverSock.sin_addr), gConnectionHost->h_addr, gConnectionHost->h_length);
	if (connect(mySocket, (sockaddr *)&serverSock, sizeof(serverSock)) == -1)
	{
		std::cerr << "Nelze navzat spojen" << std::endl;
		WSACleanup();
		return INVALID_SOCKET;
	}
	return mySocket;
}

std::string receiveText(SOCKET mySocket)
{
	int size = -1;
	char buf[BUFSIZE];
	std::string text = "";
	//while ((size != 0) && (size != -1))
	//{
	size = recv(mySocket, buf, BUFSIZE, 0);
	if (size == -1)
	{
		std::cerr << "Nelze pijmout data" << std::endl;
		return "error";
	}
	text.append(buf, buf + size);
	//}
	return text;
}

//globalni zobrazovana data
int motorLeft = 0;
int motorRight =0;
int D = 500;			//velikost zobrazeneho robota
float X = 0;			//absolutni poloha X
float Y = 0;			//absolutni poloha Y
float vl = 0;			//rychlost leveho kola
float vr = 0;			//rychlost praveho kola
int const pomer = 10;   //pomer zobrazeni v pixelech ku pocitani v cislech
float uhel = 0; //natoceni robota [rad]

DWORD WINAPI listeningServer(LPVOID lpParam)
{
	const int numberOfValues = 32;

    SOCKET mySocket = startViewerListening(IPaddress, PORT);
	if(mySocket == INVALID_SOCKET)
	{
		std::cerr << "Invalid socket...";
	}
	bool pokracuj = true;
    std::string prijataData;
    std::string prvek;

    FILE *f;
    f=fopen("data.txt","w");
	while(pokracuj)
	{
		prijataData += receiveText(mySocket);
		if(prijataData == "error")
		{
			pokracuj = false;
                        break;
		}
                int slide = 0;
                while(true){
		        prvek = getLineFromStream(prijataData,'$');
                    fprintf(f,"%s\n",prijataData.c_str());
                    if(prvek == "" || konec)
                            break;
                    float actual[numberOfValues];
                    convertReceiveData(actual, prvek);
                    nactiDoRobota(actual);
                }
        }
        fclose(f);

	return 0;
}
