//todo write OGRE render functions for rendering thread
//please use this function as main

#include <windows.h>
#include "listeningServer.h"

#include "OgreViewer.h"


DWORD WINAPI renderingRobots(LPVOID lpParam)
{
    OgreViewer *myViewer = new OgreViewer;
    if (!myViewer->nastaveno)
    {
        return 0;
    }

    //Robot *novyRobot = new Robot;
    //createRobot(myViewer, novyRobot);

    for (int i = 0;;i++)
    {
        EnterCriticalSection(&IOSection);

        for (std::map<int, robotProperties>::iterator it = robots.begin(); it != robots.end(); it++)
        {
            int id = it->second.id;
            Robot &temp = myViewer->roboti[id];
            temp.poziceX = it->second.positionX;
            temp.poziceY = it->second.positionY;
            temp.rotaceRobota = it->second.rotation;
            temp.alive = it->second.active;
            temp.rotaceKol = it->second.leftMotorSpeed / (2 * 3.1415f);
        }
        // informace o vsech simulovanych robotech jsou ve struktue robots
        // lze ji pouvat pouze v kritick sekci, tedy zde

        LeaveCriticalSection(&IOSection);

        if (!myViewer->renderFrame()) {break;}
    }

	return 0;
}

/*
class robotProperties
{
public:
	int drawingPolomer;
	int id;
	std::string name;
	bool active;
	int Rcolor;
	int Gcolor;
	int Bcolor;
	float positionX;
	float positionY;
	float rotation;
	int leftMotorPower;
	int rightMotorPower;
	int leftMotorSpeed;
	int rightMotorSpeed;
	bool led;
	bool startButton;
	int leftEncoderValue;
	int rightEncoderValue;
	int leftServoValue;
	int rightServoValue;
	bool lockLeftServo;
	bool lockRightServo;
	int sensorValues[numberOfSensors];
	std::queue<char> rs232;
};*/
